<?php
declare(strict_types=1);

namespace Inti\Wp\Middleware\Container;

use Inti\Db\Connection\ConnectionManager;
use Inti\Wp\Middleware\Bootstrap;
use Inti\Wp\Plugin\Service\PluginRunnerInterface;
use Psr\Container\ContainerInterface;

/**
 * Class BootstrapFactory
 *
 * @package Inti\Wp\Middleware\Container
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-middleware
 */
final class BootstrapFactory
{
    public function __invoke(ContainerInterface $container): Bootstrap
    {
        $config = $container->has('config') ? $container->get('config') : [];

        /** @var ConnectionManager $connManager */
        $connManager = $container->get(ConnectionManager::class);
        $runner = $container->get(PluginRunnerInterface::class);

        return new Bootstrap(
            $connManager->get($config['wp']['db_connection'] ?? 'default'),
            $runner,
            $config['wp'] ?? []
        );
    }
}
